/*{{{  tue 26th june 90*/
/*   *****************************************************   */
/*                                                           */
/* cgiprocs.h                                                */
/* Copyright (C) Division Ltd. 1990                          */
/* Tue 15th May 90                                           */
/* version 1.0                                               */
/*                                                           */
/* interface functions to the cgi library                    */
/*                                                           */
/* this defines the programmers interface                    */
/* applications should not call lower level functions        */
/*                                                           */
/* Author  : Phil Atkin, DIVISION April 1990                 */
/* Author  : Andy Hamilton, DIVISION April 1990              */
/*                                                           */
/*   *****************************************************   */
/*}}}  */

#include "cgitypes.h"

int gstack [1000];     /* used by certain graphics routines */

extern screenptr _CURRSCREEN;
extern int _COL0, COL1;
extern unsigned int font8by8[];

extern void fp_CGI_CRCL     (int Xc, int Yc, int A, int B );
extern void CGI_BIZOOM  ( screenptr s, int Xs, int Ys, int LSX, int LSY, screenptr d, int Xd, int Yd, int LDX, int LDY );

/************************* framestore definitions ************************/
extern char* fs_screenaddr (int bank );
extern void fs_displaybank ( int bank);
extern void fs_initscreen  ( screenptr s, int bank, int xSize, int ySize );
extern void fs_setpalette  ( int clutno, int red, int green, int blue );
extern void fs_initVTG     ( int *parmblock );

/************************* cgi definitions *******************************/
extern void cgi_init            (void);
extern void cgi_setdrawmode     ( int pm, int rm, int fm );
extern void cgi_setdrawscreen   ( screenptr sp );
extern void cgi_setfont         ( unsigned int *packfont, int famw, int fwpc, int flpw );
extern void cgi_setorient       ( int new );
extern void cgi_setpelstyle     ( int pxsize, int pysize, char *pelmap, int xorg, int yorg );
extern void cgi_setlinestyle    ( int n, char *ls, int zoomFac );
extern void cgi_setfillstyle    (int fxsize, int fysize, char *fillmap );
extern void cgi_setfcol         ( int Fcol );
extern void cgi_setbcol         ( int Bcol );
extern void cgi_setlineterm     ( int mode );
extern void cgi_settransparency ( int mode );
extern int  cgi_errstat         ( char *errtext, int *errqual );

extern void cgi_line         ( int X0, int Y0, int X1, int Y1 );
extern void cgi_rect         ( int X0, int Y0, int X1, int Y1 );
extern void cgi_polyline     ( int n, int *params  );
extern void cgi_disjpolyline ( int n, int *params );
extern void cgi_polygon      ( int n, int *params  );
extern void cgi_crcl         (int Xc, int Yc, int A, int B);
extern void cgi_circle       (int Xc, int Yc, int A, int B );
extern void cgi_arc          ( int Xc, int Yc, int A, int B, int DXs, int DYs, int DXe, int DYe );
extern void cgi_arcc         ( int Xc, int Yc, int A, int B, int DXs, int DYs, int DXe, int DYe, int CloseMode );
extern void cgi_strokearc    ( int Xc, int Yc, int a, int b, int Xs, int Ys, int DXe, int DYe, int CloseMode );
extern void cgi_dot          ( int X, int Y );

extern void cgi_cls     ( screenptr s, int colour );
extern void cgi_frect   ( int X0, int Y0, int X1, int Y1);
extern void cgi_fcircle ( int Xc, int Yc, int A, int B);
extern void cgi_fanfill ( int Xc, int Yc, int A, int B, int DXs, int DYs, int DXe, int DYe, int CloseMode );
extern int  cgi_search  (int Xs, int Ys, int Bcol, int sense, int dirn);
extern void cgi_paint   ( int Xs, int Ys, int Bcol );
extern void cgi_ftrap   ( int X1, int Y1, int X2, int Y2, int X3, int Y3, int X4, int Y4, int Ys, int Ye );
extern void cgi_fhline  ( int Y, int n, int *params );

extern void cgi_text      ( int X, int Y, int n, char *str );
extern void cgi_addtext   ( int n, char *str );
extern void cgi_sptext    ( int X, int Y, int n, char *str, int *dx, int *dy );
extern void cgi_addsptext ( int n, char *str, int *dx, int *dy);
extern void cgi_chrbegin  ( int X, int Y );
extern void cgi_chrspace  ( int dX, int dY );
extern void cgi_chrz      ( char data, int zlenx, int zleny);

extern void cgi_copy  ( screenptr s, int Xs, int Ys, int DX, int DY, screenptr d, int Xd, int Yd );
extern void cgi_zoom  ( screenptr s, int Xs, int Ys, int LSX, int LSY, screenptr d, int Xd, int Yd, int LDX,int LDY, int interpolate );
extern void cgi_rot   ( screenptr s, int Xs, int Ys, int LSX, int LSY, int Xd, int Yd, float angle );


/***************** undocumented and very fast bits **********************/
extern void clipline  ( screenptr s, int x0, int y0, int deltax, int deltay, int colour );
extern void cgi_shear ( screenptr s, int Xs, int Ys, int LSX, int LSY, int Xd, int Yd, int LDXx, int LDXy, int LDYx, int LDYy );
extern void cgi_yline ( int X0, int Y0, int X1, int Y1 );

/************************* end of cgidefs.h *******************************/
