/*{{{  tue 26th june 90*/
/*   *** FILE : CGITYPES.H ******************************  */
/*                                                         */
/*   cgi constant+type definitions                         */
/*                                                         */
/*   Author : Phil Atkin, DIVISION Ltd.                    */
/*   Author : Andy Hamilton, DIVISION Ltd.                 */
/*                                                         */
/*   April, May 1990                                       */
/*                                                         */
/*   ****************************************************  */
/*}}}  */

/*{{{  blitting*/
#define MOVE2DALL     0
#define MOVE2DZERO    1
#define MOVE2DNONZERO 2
/*}}}  */
/*{{{  types and structures*/
typedef unsigned char byte;
typedef unsigned int bool;
typedef void (*vfptr)();

typedef struct image {
   char *raster;
   int xsize, ysize, stride, multiMode;
} screen, *screenptr;
/*}}}  */
/*{{{  maxima and minima*/
#define onscreen(s,x,y) (((x)>=0)&((x)<s->xsize)&((y)>=0)&((y)<s->ysize))
#define screenaddr(s,x,y) ((x)+((y)*s->stride))
#define memaddr(s,x,y) (s->raster+screenaddr(s,x,y))
/*}}}  */
/*{{{  plot modes*/
#define PM_COL          0
#define PM_LINESTYLE    1
#define PM_LINESTYLETR  4
#define PM_PEL          2
#define PM_LS_PEL       3
/*}}}  */
/*{{{  fill modes*/
#define FM_COL        0
#define FM_PATTERN    1
/*}}}  */
/*{{{  arc close modes*/
#define CM_SEGMENT        0
#define CM_CHORD          1
#define CM_OPEN           2
/*}}}  */
/*{{{  replace modes*/
#define RM_ALL    MOVE2DALL
#define RM_COL    RM_ALL
#define RM_Z      MOVE2DZERO
#define RM_NZ     MOVE2DNONZERO
#define RM_AND    (RM_ALL+3)
#define RM_OR     (RM_AND+1)
#define RM_XOR    (RM_OR+1)
#define RM_NOR    (RM_XOR+1)
#define RM_NAND   (RM_NOR+1)

#define RM_TRANOP (RM_AND-1)
#define RM_BOOLOP (RM_AND)
#define RM_LASTBOOLOP (RM_NAND)
/*}}}  */
/*{{{  search modes*/
#define S_RIGHT       0
#define S_LEFT        1
#define S_WHILEGOT    2
#define S_WHILENOT    3
/*}}}  */
/*{{{  text and block copy orientation modes*/
#define TX_NORM       0     /*  0       */
#define TX_90         1     /*  90      */
#define TX_180        2     /* 180      */
#define TX_270        3     /* 270      */
#define TX_NORMFLIP   4     /* 0 flip   */
#define TX_90FLIP     5     /* 90 flip  */
#define TX_180FLIP    6     /* 180 flip */
#define TX_270FLIP    7     /* 270 filp */
/*}}}  */
/*{{{  errors*/
#define e_OK            0
#define e_BADPELMODE    1
#define e_BADREPMODE    2
#define e_BADFILLMODE   3
#define e_BADSEARCHDIRN 4
#define e_BADSEARCHTEST 5
#define e_BADSTACKMODE  6
#define e_BADFORIMODE   7
/*}}}  */
