/************************************************************/
/* INMOS Ltd.                                               */
/*                                                          */
/*          IMS F003   2D-Graphics   C Libraries            */
/*                                                          */
/*      Example program                  Indy/Olly  1990    */
/*                                                          */
/************************************************************/

#include <channel.h>
#include <stdio.h>
#include <mathf.h>
#include <math.h>
#include <stdlib.h>

#include "cgidefs.h"


void palette ()
{
  int clutloc=0;
  int colour=0;

  for (clutloc=0; clutloc<64; clutloc++)
  {
    colour = clutloc*4;
    fs_setpalette (clutloc,colour,colour,colour); /* grey  scale */
    fs_setpalette (clutloc+64 ,colour,0,0);       /* red   scale */
    fs_setpalette (clutloc+128,0,colour,0);       /* green scale */
    fs_setpalette (clutloc+192,0,0,colour);       /* blue  scale */
  }
}


int boxThere (x,y)
int x,y;
{
  static int xMissing[] = { 0, 1, 0, 0, 1, 0, 7, 7 } ;
  static int yMissing[] = { 0, 0, 1, 7, 7, 6, 6, 7 } ;
  int i;

  for (i=0;i<8;i++)
    if (((xMissing [i] == x) && (yMissing [i] == y)) ||
            ((yMissing [i] == x) && (xMissing [i] == y)))
      return (0);
  return (1);
}


void logo (x0,y0,rad,fg_col,bg_col)
int x0,y0;           /* top left coords     */
int rad;             /* radius              */
int fg_col,bg_col;   /* box, circle colours */
{
  int boxEdge,holeEdge;
  int xc, yc ;
  int xt, yt ;

  boxEdge=rad/5;
  holeEdge=rad/39;
  xc = (x0 + rad) + 9;
  yc = (y0 + rad) + 9;
  cgi_setfcol(bg_col);
  cgi_fcircle (xc,yc,rad,rad);
  {
    int x0 = (xc - (boxEdge << 2 )) - ((holeEdge * 7) / 2) ;
    int y0 = (yc - (boxEdge << 2 )) - ((holeEdge * 7) / 2) ;
    int x,y;

    for (x=0;x<8;x++)
      for (y=0;y<8;y++)
        if (boxThere (x,y))
        {
          xt= x0 + ((boxEdge+holeEdge) * x);
          yt= y0 + ((boxEdge+holeEdge) * y);
          cgi_setfcol(fg_col);
          cgi_frect (xt,yt,xt+boxEdge,yt+boxEdge);
        }
  }
}


screen screens [2];
int visible_screen, invisible_screen;

/* These parms are suitable for 1024 by 1024
   on 50-60kHz linescan monitor */

int g3parms[] = {17,17,43,256,87,164,6,56,2048,338,0,491,21,255};


int main ()
{
  int loop1,loop2;
  char text1[] = {"inmos ltd"};
  char text2[] = {"IMS F003  C  Graphics  Libraries"};

  cgi_init ();
  fs_initVTG (g3parms);
  visible_screen = 0;
  invisible_screen = 1;
  fs_initscreen (&screens [visible_screen  ],visible_screen  ,1024,1024);
  fs_initscreen (&screens [invisible_screen],invisible_screen,1024,1024);
  fs_displaybank (visible_screen);
  palette ();

  cgi_setdrawscreen (&screens[visible_screen]);
  cgi_setfcol (127);
  cgi_cls (&screens [visible_screen],255);
  cgi_cls (&screens [invisible_screen],255);
  for (loop1=0;loop1<256;loop1++)
  {
    cgi_setfcol (loop1);
    for (loop2=0;loop2<4;loop2++)
      cgi_line ((loop1*4)+loop2,0,(loop1*4)+loop2,1023);
  }
  cgi_setdrawmode (PM_COL, RM_XOR, FM_COL);
  for (loop1=0;loop1<256;loop1++)
  {
    cgi_setfcol (loop1);
    for (loop2=0;loop2<4;loop2++)
      cgi_line (0,(loop1*4)+loop2,1023,(loop1*4)+loop2);
  }
  cgi_setdrawmode (PM_COL, RM_COL, FM_COL);
  for (loop1=0;loop1<64;loop1++)
  {
    cgi_setfcol (loop1);
    for (loop2=0;loop2<8;loop2++)
      cgi_line (256,256+(loop1*8)+loop2,768,256+(loop1*8)+loop2);
  }
  cgi_setfcol (63);
  cgi_rect (256,256,768,768);
  logo (270,390,100,40,20);
  cgi_setfont (font8by8, 8, 2, 4);
  cgi_setorient (TX_NORM);
  cgi_chrspace (10,0);
  cgi_setfcol (127);
  cgi_setdrawmode (PM_COL, RM_XOR, FM_COL);
  for (loop1=0;loop1<9;loop1++)
  {
    cgi_chrbegin (518+(loop1*23),497);
    cgi_chrz (text1[loop1],20,20);
  }
  for (loop1=0;loop1<32;loop1++)
  {
    cgi_chrbegin (290+(loop1*14),700);
    cgi_chrz (text2[loop1],12,14);
  }
}

